﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms;
using System.Drawing.Drawing2D;

namespace TextBoxExt_BackColor
{
    public partial class Form1 : MetroForm
    {
        #region Declartaion
        //Initialzie the Close button rectangle
        Rectangle closebutton;
		//Initializes the LinearGradientBrush.
LinearGradientBrush gradientBrush;
       
        #endregion

        #region Constructor
        public Form1()
        {
            InitializeComponent();
			//tabControlAdv1.CloseButtonBackColor
			//To draw the Tab item
            this.tabControlAdv1.DrawItem += new DrawTabEventHandler(tabControlAdv1_DrawItem);
			this.tabControlAdv1.MouseClick += TabControlAdv1_MouseClick;
			this.tabControlAdv1.MouseMove += TabControlAdv1_MouseMove;
		}

		private void TabControlAdv1_MouseMove(object sender, MouseEventArgs e)
		{
			for (int i = 0; i < this.tabControlAdv1.TabPages.Count; i++)
			{
				Rectangle r = this.tabControlAdv1.GetTabRect(i);

				if (r.Contains(e.Location))
				{
					toolTip1.SetToolTip(tabControlAdv1, this.tabControlAdv1.TabPages[i].Text);
					break;
				}
			}
			return;
		}
	

		private void TabControlAdv1_MouseClick(object sender, MouseEventArgs e)
		{
			for (int i = 0; i < this.tabControlAdv1.TabPages.Count; i++)
			{
				Rectangle r = closebutton;
				if (closebutton.Contains(e.Location))
				{
					tabControlAdv1.TabPages.Remove(tabControlAdv1.SelectedTab);
					break;
				}
			}
		}
		#endregion

		#region Events
		void tabControlAdv1_DrawItem(object sender, DrawTabEventArgs drawItemInfo)
        {
			// The function GetTabRect helps to get the rectangle of the tab item.
			if (drawItemInfo.Index != this.tabControlAdv1.SelectedIndex)
			{
                // For the non-selected tabs.
                gradientBrush = new System.Drawing.Drawing2D.LinearGradientBrush(this.tabControlAdv1.GetTabRect(drawItemInfo.Index), tabControlAdv1.InactiveTabColor, tabControlAdv1.InactiveTabColor, LinearGradientMode.Horizontal);               
            }
			else
			{
                // For the selected tab.
                gradientBrush = new System.Drawing.Drawing2D.LinearGradientBrush(this.tabControlAdv1.GetTabRect(drawItemInfo.Index), tabControlAdv1.ActiveTabColor, tabControlAdv1.ActiveTabColor, LinearGradientMode.Horizontal);                
            }
			float[] positions = { 0.0f, 0.05f, 0.95f, 1.0f };
			float[] factors = { 0.4f, 1.0f, 0.05f, 0.04f };
			// Blends settings.
			Blend blend = new Blend();
			blend.Factors = factors;
			blend.Positions = positions;
			gradientBrush.Blend = blend;
			drawItemInfo.Graphics.FillRectangle(gradientBrush, this.tabControlAdv1.GetTabRect(drawItemInfo.Index));
			gradientBrush.Dispose();

			// Draw the default borders and interior (text and image)
			drawItemInfo.DrawBorders();
            // To draw Image
            drawItemInfo.Graphics.DrawImage(this.tabControlAdv1.TabPages[drawItemInfo.Index].Image, new Rectangle(drawItemInfo.Bounds.X + 5, drawItemInfo.Bounds.Y + 5, this.tabControlAdv1.TabPages[drawItemInfo.Index].ImageSize.Width, this.tabControlAdv1.TabPages[drawItemInfo.Index].ImageSize.Height));
			//To draw the text of the Tab item
			if (drawItemInfo.Index != this.tabControlAdv1.SelectedIndex)
			{

				// For the non-selected tabs.  
				Size size = TextRenderer.MeasureText(this.tabControlAdv1.TabPages[drawItemInfo.Index].Text, tabControlAdv1.ActiveTabFont);
				StringFormat format = new StringFormat();
				format.Trimming = StringTrimming.EllipsisCharacter;
				TextRenderer.DrawText(drawItemInfo.Graphics, this.tabControlAdv1.TabPages[drawItemInfo.Index].Text, this.tabControlAdv1.TabPages[drawItemInfo.Index].Font
				, new Rectangle(drawItemInfo.Bounds.X + 25, drawItemInfo.Bounds.Y + 7, drawItemInfo.Bounds.Width - 40, drawItemInfo.Bounds.Height), Color.Black, TextFormatFlags.EndEllipsis);
			}
			else
			{
				// For the selected tab.
				Size size = TextRenderer.MeasureText(this.tabControlAdv1.TabPages[drawItemInfo.Index].Text, tabControlAdv1.ActiveTabFont);
				StringFormat format = new StringFormat();
				format.Trimming = StringTrimming.Character;
				TextRenderer.DrawText(drawItemInfo.Graphics, this.tabControlAdv1.TabPages[drawItemInfo.Index].Text, this.tabControlAdv1.TabPages[drawItemInfo.Index].Font
				, new Rectangle(drawItemInfo.Bounds.X + 25, drawItemInfo.Bounds.Y + 7, drawItemInfo.Bounds.Width - 40, drawItemInfo.Bounds.Height), Color.Black, TextFormatFlags.EndEllipsis);


			}
			//For Close Button 
			closebutton = new Rectangle(drawItemInfo.Bounds.X + drawItemInfo.Bounds.Width - 20, drawItemInfo.Bounds.Y + 7, 13, 13);
			//To draw the close button rectangle
			drawItemInfo.Graphics.FillRectangle(Brushes.Red, closebutton);
			// To draw "X" in Red color rectangle
			drawItemInfo.Graphics.DrawLine(new Pen(Brushes.White), new Point(closebutton.X + 4, closebutton.Y + 4), new Point(closebutton.X + closebutton.Width - 4, closebutton.Y + closebutton.Height - 4));
			drawItemInfo.Graphics.DrawLine(new Pen(Brushes.White), new Point(closebutton.X + 4, closebutton.Y - 4 + closebutton.Height), new Point(closebutton.X + closebutton.Width - 4, closebutton.Y + 4));
		}
		
		#endregion
	}
}